blob: 91ffdfa2cc4e2253e07bee3a81c6ef2881eb4fe5 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Alex Lightea1e7702016-07-11 13:39:55 -070044export JAVAC="javac -g -Xlint:-options"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Nicolas Geoffray1c5b6da2016-03-16 10:55:57 +000048export USE_JACK="true"
Alex Lightb55f1ac2016-04-12 15:50:55 -070049export SMALI_ARGS="--experimental"
jeffhao5d1ac922011-09-29 17:41:15 -070050
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070051# If dx was not set by the environment variable, assume it is in the path.
52if [ -z "$DX" ]; then
53 export DX="dx"
54fi
55
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080056# If jasmin was not set by the environment variable, assume it is in the path.
57if [ -z "$JASMIN" ]; then
58 export JASMIN="jasmin"
59fi
60
Andreas Gampe8fda9f22014-10-03 16:15:37 -070061# If smali was not set by the environment variable, assume it is in the path.
62if [ -z "$SMALI" ]; then
63 export SMALI="smali"
64fi
65
66# If dexmerger was not set by the environment variable, assume it is in the path.
67if [ -z "$DXMERGER" ]; then
68 export DXMERGER="dexmerger"
69fi
70
Sebastien Hertz19ac0272015-02-24 17:39:50 +010071# If jack was not set by the environment variable, assume it is in the path.
72if [ -z "$JACK" ]; then
73 export JACK="jack"
74fi
75
Sebastien Hertz19ac0272015-02-24 17:39:50 +010076# ANDROID_BUILD_TOP is not set in a build environment.
77if [ -z "$ANDROID_BUILD_TOP" ]; then
78 export ANDROID_BUILD_TOP=$oldwd
79fi
80
Andreas Gampef47fb2f2016-06-24 22:30:29 -070081# ANDROID_HOST_OUT is not set in a build environment.
82if [ -z "$ANDROID_HOST_OUT" ]; then
Dan Willemsenf325e012017-03-03 12:35:30 -080083 export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out}/host/linux-x86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070084fi
85
Sebastien Hertz19ac0272015-02-24 17:39:50 +010086# If JACK_CLASSPATH is not set, assume it only contains core-libart.
87if [ -z "$JACK_CLASSPATH" ]; then
Andreas Gampef47fb2f2016-06-24 22:30:29 -070088 export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack"
Sebastien Hertz19ac0272015-02-24 17:39:50 +010089fi
90
Sebastien Hertz19ac0272015-02-24 17:39:50 +010091export JACK="$JACK -g -cp $JACK_CLASSPATH"
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080092
Igor Murashkin271a0f82017-02-14 21:14:17 +000093# Zipalign is not on the PATH in some configs, auto-detect it.
94if [ -z "$ZIPALIGN" ]; then
95 if which zipalign >/dev/null; then
96 ZIPALIGN="zipalign";
97 else
98 # TODO: Add a dependency for zipalign in Android.run-test.mk
99 # once it doesn't depend on libandroidfw (b/35246701)
100 case "$OSTYPE" in
101 darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
102 linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
103 *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
104 esac
105 fi
106fi
107export ZIPALIGN
108
jeffhao5d1ac922011-09-29 17:41:15 -0700109info="info.txt"
110build="build"
111run="run"
112expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700113check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -0700114output="output.txt"
115build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100116cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700117strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700118lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700119testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700120run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000121build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700122
Alex Light91de25f2015-10-28 17:00:06 -0700123quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000124debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700125prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700126target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700127dev_mode="no"
128update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700129debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000130relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800131runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700132usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700133build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700134suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700135trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700136trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700137basic_verify="false"
138gc_verify="false"
139gc_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700140strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700141always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700142never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700143have_dex2oat="yes"
144have_patchoat="yes"
145have_image="yes"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800146multi_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000147android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700148bisection_search="no"
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800149suspend_timeout="500000"
Alex Light10bc5a42016-05-10 10:01:22 -0700150# By default we will use optimizing.
151image_args=""
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000152image_suffix=""
jeffhao5d1ac922011-09-29 17:41:15 -0700153
154while true; do
155 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700156 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700157 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100158 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700159 shift
Alex Light91de25f2015-10-28 17:00:06 -0700160 elif [ "x$1" = "x--quiet" ]; then
161 quiet="yes"
162 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700163 elif [ "x$1" = "x--use-java-home" ]; then
164 if [ -n "${JAVA_HOME}" ]; then
165 export JAVA="${JAVA_HOME}/bin/java"
166 export JAVAC="${JAVA_HOME}/bin/javac -g"
167 else
168 echo "Passed --use-java-home without JAVA_HOME variable set!"
169 usage="yes"
170 fi
171 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800172 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700173 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800174 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800175 runtime="jvm"
Alex Lightbc90d0f2016-05-09 16:21:09 -0700176 image_args=""
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700177 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700178 NEED_DEX="false"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100179 USE_JACK="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100180 run_args="${run_args} --jvm"
Alex Lighteb7c1442015-08-31 13:17:42 -0700181 build_args="${build_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700182 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800183 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700184 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700185 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700186 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700187 shift
188 elif [ "x$1" = "x--dalvik" ]; then
189 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800190 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700191 shift
Alex Light03a112d2014-08-25 13:25:56 -0700192 elif [ "x$1" = "x--no-dex2oat" ]; then
193 have_dex2oat="no"
194 shift
195 elif [ "x$1" = "x--no-patchoat" ]; then
196 have_patchoat="no"
197 shift
198 elif [ "x$1" = "x--no-image" ]; then
199 have_image="no"
200 shift
Jeff Haodcdc85b2015-12-04 14:06:18 -0800201 elif [ "x$1" = "x--multi-image" ]; then
202 multi_image_suffix="-multi"
203 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700204 elif [ "x$1" = "x--pic-test" ]; then
205 run_args="${run_args} --pic-test"
206 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700207 elif [ "x$1" = "x--relocate" ]; then
208 relocate="yes"
209 shift
210 elif [ "x$1" = "x--no-relocate" ]; then
211 relocate="no"
212 shift
213 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100214 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700215 prebuild_mode="yes"
216 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700217 elif [ "x$1" = "x--strip-dex" ]; then
218 run_args="${run_args} --strip-dex"
219 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000220 elif [ "x$1" = "x--debuggable" ]; then
221 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000222 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000223 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700224 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100225 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700226 prebuild_mode="no"
227 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700228 elif [ "x$1" = "x--gcverify" ]; then
229 basic_verify="true"
230 gc_verify="true"
231 shift
232 elif [ "x$1" = "x--gcstress" ]; then
233 basic_verify="true"
234 gc_stress="true"
235 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800236 elif [ "x$1" = "x--suspend-timeout" ]; then
237 shift
238 suspend_timeout="$1"
239 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700240 elif [ "x$1" = "x--image" ]; then
241 shift
242 image="$1"
243 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700244 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000245 elif [ "x$1" = "x-Xcompiler-option" ]; then
246 shift
247 option="$1"
248 run_args="${run_args} -Xcompiler-option $option"
249 shift
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000250 elif [ "x$1" = "x--build-option" ]; then
251 shift
252 option="$1"
253 build_args="${build_args} $option"
254 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700255 elif [ "x$1" = "x--runtime-option" ]; then
256 shift
257 option="$1"
258 run_args="${run_args} --runtime-option $option"
259 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700260 elif [ "x$1" = "x--gdb-arg" ]; then
261 shift
262 gdb_arg="$1"
263 run_args="${run_args} --gdb-arg $gdb_arg"
264 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700265 elif [ "x$1" = "x--debug" ]; then
266 run_args="${run_args} --debug"
267 shift
268 elif [ "x$1" = "x--gdb" ]; then
269 run_args="${run_args} --gdb"
270 dev_mode="yes"
271 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700272 elif [ "x$1" = "x--strace" ]; then
273 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700274 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700275 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700276 elif [ "x$1" = "x--zygote" ]; then
277 run_args="${run_args} --zygote"
278 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800279 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000280 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700281 image_suffix="-interpreter"
282 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800283 elif [ "x$1" = "x--jit" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700284 image_args="--jit"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000285 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800286 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700287 elif [ "x$1" = "x--optimizing" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700288 image_args="-Xcompiler-option --compiler-backend=Optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800289 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700290 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700291 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700292 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700293 elif [ "x$1" = "x--verify-soft-fail" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700294 image_args="--verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700295 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700296 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700297 elif [ "x$1" = "x--no-optimize" ]; then
298 run_args="${run_args} --no-optimize"
299 shift
300 elif [ "x$1" = "x--no-precise" ]; then
301 run_args="${run_args} --no-precise"
302 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700303 elif [ "x$1" = "x--invoke-with" ]; then
304 shift
305 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700306 if [ "x$what" = "x" ]; then
307 echo "$0 missing argument to --invoke-with" 1>&2
308 usage="yes"
309 break
310 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700311 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700312 shift
313 elif [ "x$1" = "x--dev" ]; then
314 run_args="${run_args} --dev"
315 dev_mode="yes"
316 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700317 elif [ "x$1" = "x--build-only" ]; then
318 build_only="yes"
319 shift
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100320 elif [ "x$1" = "x--build-with-javac-dx" ]; then
321 USE_JACK="false"
322 shift
323 elif [ "x$1" = "x--build-with-jack" ]; then
324 USE_JACK="true"
325 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700326 elif [ "x$1" = "x--output-path" ]; then
327 shift
328 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700329 if [ "x$tmp_dir" = "x" ]; then
330 echo "$0 missing argument to --output-path" 1>&2
331 usage="yes"
332 break
333 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700334 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000335 elif [ "x$1" = "x--android-root" ]; then
336 shift
337 if [ "x$1" = "x" ]; then
338 echo "$0 missing argument to --android-root" 1>&2
339 usage="yes"
340 break
341 fi
342 android_root="$1"
343 run_args="${run_args} --android-root $1"
344 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700345 elif [ "x$1" = "x--update" ]; then
346 update_mode="yes"
347 shift
348 elif [ "x$1" = "x--help" ]; then
349 usage="yes"
350 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700351 elif [ "x$1" = "x--64" ]; then
352 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700353 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700354 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200355 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700356 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200357 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700358 elif [ "x$1" = "x--stream" ]; then
359 trace_stream="true"
360 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700361 elif [ "x$1" = "x--always-clean" ]; then
362 always_clean="yes"
363 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700364 elif [ "x$1" = "x--never-clean" ]; then
365 never_clean="yes"
366 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800367 elif [ "x$1" = "x--dex2oat-swap" ]; then
368 run_args="${run_args} --dex2oat-swap"
369 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700370 elif [ "x$1" = "x--instruction-set-features" ]; then
371 shift
372 run_args="${run_args} --instruction-set-features $1"
373 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700374 elif [ "x$1" = "x--bisection-search" ]; then
375 bisection_search="yes"
376 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000377 elif [ "x$1" = "x--vdex" ]; then
378 run_args="${run_args} --vdex"
379 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000380 elif [ "x$1" = "x--vdex-filter" ]; then
381 shift
382 filter=$1
383 run_args="${run_args} --vdex-filter $filter"
384 shift
Jeff Hao002b9312017-03-27 16:23:08 -0700385 elif [ "x$1" = "x--random-profile" ]; then
386 run_args="${run_args} --random-profile"
387 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700388 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700389 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700390 usage="yes"
391 break
392 else
393 break
394 fi
395done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700396
Alex Light10bc5a42016-05-10 10:01:22 -0700397run_args="${run_args} ${image_args}"
Alex Light91de25f2015-10-28 17:00:06 -0700398# Allocate file descriptor real_stderr and redirect it to the shell's error
399# output (fd 2).
400if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
401 exec {real_stderr}>&2
402else
403 # In bash before version 4.1 we need to do a manual search for free file
404 # descriptors.
405 FD=3
406 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
407 real_stderr=$FD
408 eval "exec ${real_stderr}>&2"
409fi
410if [ "$quiet" = "yes" ]; then
411 # Force the default standard output and error to go to /dev/null so we will
412 # not print them.
413 exec 1>/dev/null
414 exec 2>/dev/null
415fi
416
417function err_echo() {
418 echo "$@" 1>&${real_stderr}
419}
420
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700421# tmp_dir may be relative, resolve.
422#
423# Cannot use realpath, as it does not exist on Mac.
424# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700425# Cannot use readlink -m, as it does not exist on Mac.
426# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700427noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700428tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700429mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700430
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800431# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000432if [ ! "$runtime" = "jvm" ]; then
433 run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout"
434fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800435
Alex Lighte7873ec2014-08-12 09:53:50 -0700436if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800437 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
438 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700439fi
440if [ "$gc_verify" = "true" ]; then
441 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
442fi
443if [ "$gc_stress" = "true" ]; then
Mathieu Chartierd9eb2842016-08-12 16:11:24 -0700444 run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700445fi
Jeff Hao85139a32014-07-23 11:52:52 -0700446if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700447 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
448 if [ "$trace_stream" = "true" ]; then
449 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
450 # the ability to analyze the file and just write to /dev/null.
451 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
452 # Enable streaming mode.
453 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
454 else
455 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
456 fi
457elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700458 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700459 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700460fi
461
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700462# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100463# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100464function guess_target_arch_name() {
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100465 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
Andreas Gampe1a5c4062015-01-15 12:10:47 -0800466 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700467 if [ "x${suffix64}" = "x64" ]; then
468 target_arch_name=${grep64bit}
469 else
470 target_arch_name=${grep32bit}
471 fi
472}
473
David Brazdil853a4c32015-09-28 16:15:50 +0100474function guess_host_arch_name() {
475 if [ "x${suffix64}" = "x64" ]; then
476 host_arch_name="x86_64"
477 else
478 host_arch_name="x86"
479 fi
480}
481
Alex Lighta59dd802014-07-02 16:28:08 -0700482if [ "$target_mode" = "no" ]; then
483 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700484 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700485 err_echo "--prebuild with --jvm is unsupported"
Alex Lighta59dd802014-07-02 16:28:08 -0700486 exit 1;
487 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700488 fi
489fi
490
Alex Light03a112d2014-08-25 13:25:56 -0700491if [ "$have_patchoat" = "no" ]; then
492 run_args="${run_args} --no-patchoat"
493fi
494
495if [ "$have_dex2oat" = "no" ]; then
496 run_args="${run_args} --no-dex2oat"
497fi
498
Jeff Hao201803f2013-11-20 18:11:39 -0800499if [ ! "$runtime" = "jvm" ]; then
500 run_args="${run_args} --lib $lib"
501fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700502
Jeff Hao201803f2013-11-20 18:11:39 -0800503if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700504 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100505 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800506 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700507 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700508 else
509 true # defaults to using target BOOTCLASSPATH
510 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800511elif [ "$runtime" = "art" ]; then
512 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100513 guess_host_arch_name
Richard Uhlerbb00f812017-02-16 14:21:10 +0000514 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${multi_image_suffix}.art"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700515 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800516 else
David Brazdil853a4c32015-09-28 16:15:50 +0100517 guess_target_arch_name
Dimitry Ivanov49c2c922017-02-14 11:06:14 -0800518 run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}"
Richard Uhlerbb00f812017-02-16 14:21:10 +0000519 run_args="${run_args} --boot /data/art-test/core${image_suffix}${multi_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800520 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700521 if [ "$relocate" = "yes" ]; then
522 run_args="${run_args} --relocate"
523 else
524 run_args="${run_args} --no-relocate"
525 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700526elif [ "$runtime" = "jvm" ]; then
527 # TODO: Detect whether the host is 32-bit or 64-bit.
Alex Lightfba89fe2017-01-12 16:11:02 -0800528 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700529fi
530
Alex Light03a112d2014-08-25 13:25:56 -0700531if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700532 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700533 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700534 exit 1
535 fi
Alex Light03a112d2014-08-25 13:25:56 -0700536 run_args="${run_args} --no-image"
537fi
538
jeffhao5d1ac922011-09-29 17:41:15 -0700539if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700540 err_echo "--dev and --update are mutually exclusive"
541 usage="yes"
542fi
543
544if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
545 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700546 usage="yes"
547fi
548
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700549if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
550 err_echo "--bisection-search and --prebuild are mutually exclusive"
551 usage="yes"
552fi
553
554if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then
555 err_echo "--bisection-search and --no-dex2oat are mutually exclusive"
556 usage="yes"
557fi
558
559if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then
560 err_echo "--bisection-search and --no-patchoat are mutually exclusive"
561 usage="yes"
562fi
563
jeffhao5d1ac922011-09-29 17:41:15 -0700564if [ "$usage" = "no" ]; then
565 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
566 test_dir=`basename "$oldwd"`
567 else
568 test_dir="$1"
569 fi
570
571 if [ '!' -d "$test_dir" ]; then
572 td2=`echo ${test_dir}-*`
573 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700574 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700575 usage="yes"
576 fi
577 test_dir="$td2"
578 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700579 # Shift to get rid of the test name argument. The rest of the arguments
580 # will get passed to the test run.
581 shift
582fi
583
Søren Gjesse620d0a52016-09-19 11:12:51 +0200584# For building with javac and dx always use Java 7. The dx compiler
585# only support byte codes from Java 7 or earlier (class file major
586# version 51 or lower).
587if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then
588 export JAVAC="${JAVAC} -source 1.7 -target 1.7"
589fi
590
jeffhao5d1ac922011-09-29 17:41:15 -0700591if [ "$usage" = "yes" ]; then
592 prog=`basename $prog`
593 (
594 echo "usage:"
595 echo " $prog --help Print this message."
596 echo " $prog [options] [test-name] Run test normally."
597 echo " $prog --dev [options] [test-name] Development mode" \
598 "(dumps to stdout)."
599 echo " $prog --update [options] [test-name] Update mode" \
600 "(replaces expected.txt)."
601 echo ' Omitting the test name or specifying "-" will use the' \
602 "current directory."
603 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000604 echo " -O Run non-debug rather than debug build (off by default)."
605 echo " -Xcompiler-option Pass an option to the compiler."
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000606 echo " --build-option Pass an option to the build script."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000607 echo " --runtime-option Pass an option to the runtime."
608 echo " --debug Wait for a debugger to attach."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000609 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000610 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700611 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000612 echo " --build-only Build test files only (off by default)."
Søren Gjesse620d0a52016-09-19 11:12:51 +0200613 echo " --build-with-javac-dx Build test files with javac and dx (off by default)."
614 echo " --build-with-jack Build test files with jack and jill (on by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000615 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800616 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000617 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000618 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700619 echo " --verify-soft-fail Force soft fail verification (off by default)."
620 echo " Verification is enabled if neither --no-verify"
621 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000622 echo " --no-optimize Turn off optimization (on by default)."
623 echo " --no-precise Turn off precise GC (on by default)."
624 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700625 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000626 echo " other runtime options are ignored."
627 echo " --no-dex2oat Run as though dex2oat was failing."
628 echo " --no-patchoat Run as though patchoat was failing."
629 echo " --prebuild Run dex2oat on the files before starting test. (default)"
630 echo " --no-prebuild Do not run dex2oat on the files before starting"
631 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700632 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000633 echo " --relocate Force the use of relocating in the test, making"
634 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000635 echo " address before running."
636 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700637 echo " --image Run the test using a precompiled boot image. (default)"
638 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000639 echo " --host Use the host-mode virtual machine."
640 echo " --invoke-with Pass --invoke-with option to runtime."
641 echo " --dalvik Use Dalvik (off by default)."
642 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700643 echo " --use-java-home Use the JAVA_HOME environment variable"
644 echo " to find the java compiler and runtime"
645 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000646 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700647 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000648 echo " --64 Run the test in 64-bit mode"
649 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700650 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700651 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000652 echo " --gcstress Run with gc stress testing"
653 echo " --gcverify Run with gc verification"
654 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700655 echo " --never-clean Keep the test files even if the test succeeds."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000656 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000657 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700658 echo " --instruction-set-features [string]"
659 echo " Set instruction-set-features for compilation."
Jeff Haodcdc85b2015-12-04 14:06:18 -0800660 echo " --multi-image Use a set of images compiled with dex2oat multi-image for"
661 echo " the boot class path."
Alex Lightfadfee92015-10-28 09:40:10 -0700662 echo " --pic-test Compile the test code position independent."
Alex Light91de25f2015-10-28 17:00:06 -0700663 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700664 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000665 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800666 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Alex Light91de25f2015-10-28 17:00:06 -0700667 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700668 exit 1
669fi
670
671cd "$test_dir"
672test_dir=`pwd`
673
674td_info="${test_dir}/${info}"
675td_expected="${test_dir}/${expected}"
676
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700677if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700678 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700679 exit 1
680fi
681
682if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700683 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700684 exit 1
685fi
686
687# copy the test to a temp dir and run it
688
Elliott Hughes510c8782011-10-06 10:57:34 -0700689echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700690
691rm -rf "$tmp_dir"
692cp -Rp "$test_dir" "$tmp_dir"
693cd "$tmp_dir"
694
695if [ '!' -r "$build" ]; then
696 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800697else
698 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700699fi
700
701if [ '!' -r "$run" ]; then
702 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800703else
704 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700705fi
706
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700707if [ '!' -r "$check_cmd" ]; then
708 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800709else
710 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700711fi
712
jeffhao5d1ac922011-09-29 17:41:15 -0700713chmod 755 "$build"
714chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700715chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700716
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700717export TEST_NAME=`basename ${test_dir}`
718
Roland Levillain0d5a2812015-11-13 10:07:31 +0000719# arch_supports_read_barrier ARCH
720# -------------------------------
721# Return whether the Optimizing compiler has read barrier support for ARCH.
722function arch_supports_read_barrier() {
Roland Levillain22ccc3a2015-11-24 13:10:05 +0000723 # Optimizing has read barrier support for ARM, ARM64, x86 and x86-64 at the
Roland Levillain0d5a2812015-11-13 10:07:31 +0000724 # moment.
Roland Levillain22ccc3a2015-11-24 13:10:05 +0000725 [ "x$1" = xarm ] || [ "x$1" = xarm64 ] || [ "x$1" = xx86 ] || [ "x$1" = xx86_64 ]
Roland Levillain0d5a2812015-11-13 10:07:31 +0000726}
727
David Brazdil4846d132015-01-15 19:07:08 +0000728# Tests named '<number>-checker-*' will also have their CFGs verified with
729# Checker when compiled with Optimizing on host.
730if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000731 if [ "$runtime" = "art" -a "$image_suffix" = "" -a "$USE_JACK" = "true" ]; then
Roland Levillain0d5a2812015-11-13 10:07:31 +0000732 # Optimizing has read barrier support for certain architectures
733 # only. On other architectures, compiling is disabled when read
734 # barriers are enabled, meaning that we do not produce a CFG file
735 # as a side-effect of compilation, thus the Checker assertions
736 # cannot be checked. Disable Checker for those cases.
737 #
738 # TODO: Enable Checker when read barrier support is added to more
739 # architectures (b/12687968).
Hiroshi Yamauchifd3161a2017-01-18 14:47:25 -0800740 if [ "x$ART_USE_READ_BARRIER" != xfalse ] \
Roland Levillain0d5a2812015-11-13 10:07:31 +0000741 && (([ "x$host_mode" = "xyes" ] \
742 && ! arch_supports_read_barrier "$host_arch_name") \
743 || ([ "x$target_mode" = "xyes" ] \
744 && ! arch_supports_read_barrier "$target_arch_name")); then
745 run_checker="no"
David Brazdil80fb3942015-07-23 11:53:42 +0100746 # In no-prebuild mode, the compiler is only invoked if both dex2oat and
747 # patchoat are available. Disable Checker otherwise (b/22552692).
Roland Levillain0d5a2812015-11-13 10:07:31 +0000748 elif [ "$prebuild_mode" = "yes" ] \
749 || [ "$have_patchoat" = "yes" -a "$have_dex2oat" = "yes" ]; then
David Brazdil80fb3942015-07-23 11:53:42 +0100750 run_checker="yes"
David Brazdil5cc343d2015-10-08 11:35:32 +0100751
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100752 if [ "$target_mode" = "no" ]; then
753 cfg_output_dir="$tmp_dir"
David Brazdil5cc343d2015-10-08 11:35:32 +0100754 checker_args="--arch=${host_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100755 else
756 cfg_output_dir="$DEX_LOCATION"
David Brazdil5cc343d2015-10-08 11:35:32 +0100757 checker_args="--arch=${target_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100758 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100759
760 if [ "$debuggable" = "yes" ]; then
761 checker_args="$checker_args --debuggable"
762 fi
763
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100764 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
David Brazdil80fb3942015-07-23 11:53:42 +0100765 -Xcompiler-option -j1"
766 fi
David Brazdil4846d132015-01-15 19:07:08 +0000767 fi
768fi
769
Mathieu Chartier031768a2015-08-27 10:25:02 -0700770 run_args="${run_args} --testlib ${testlib}"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700771
Richard Uhler020c0f32017-03-14 16:23:17 +0000772# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and
773# ART output to approximately 128MB. This should be more than sufficient
774# for any test while still catching cases of runaway output.
775# Set a hard limit to encourage ART developers to increase the ulimit here if
776# needed to support a test case rather than resetting the limit in the run
777# script for the particular test in question.
Orion Hodsonbd328d32017-03-24 11:24:10 +0000778if ! ulimit -f 128000; then
Richard Uhler020c0f32017-03-14 16:23:17 +0000779 err_echo "ulimit file size setting failed"
Ian Rogers997f0f92014-06-21 22:58:05 -0700780fi
781
jeffhao5d1ac922011-09-29 17:41:15 -0700782good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000783good_build="yes"
784good_run="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700785if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000786 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700787 build_exit="$?"
788 echo "build exit status: $build_exit" 1>&2
789 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800790 echo "${test_dir}: running..." 1>&2
791 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700792 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000793
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800794 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000795 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100796 if [ "$target_mode" = "yes" ]; then
797 adb pull $cfg_output_dir/$cfg_output &> /dev/null
798 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100799 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000800 checker_exit="$?"
801 if [ "$checker_exit" = "0" ]; then
802 good="yes"
803 fi
Alex Light91de25f2015-10-28 17:00:06 -0700804 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000805 else
806 good="yes"
807 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800808 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000809 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700810 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700811elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000812 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700813 build_exit="$?"
814 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800815 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700816 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000817 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100818 if [ "$target_mode" = "yes" ]; then
819 adb pull $cfg_output_dir/$cfg_output &> /dev/null
820 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100821 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000822 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700823 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
824 good="yes"
825 else
Alex Light91de25f2015-10-28 17:00:06 -0700826 cat "$build_output" 1>&${real_stderr} 1>&2
827 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700828 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700829elif [ "$build_only" = "yes" ]; then
830 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000831 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700832 build_exit="$?"
833 if [ "$build_exit" '!=' '0' ]; then
834 cp "$build_output" "$output"
835 echo "build exit status: $build_exit" >>"$output"
836 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
837 if [ "$?" '!=' "0" ]; then
838 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700839 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700840 fi
841 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700842 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700843 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700844 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700845else
David Brazdil4846d132015-01-15 19:07:08 +0000846 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700847 build_exit="$?"
848 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800849 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700850 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000851 run_exit="$?"
852 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700853 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000854 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000855 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100856 if [ "$target_mode" = "yes" ]; then
857 adb pull $cfg_output_dir/$cfg_output &> /dev/null
858 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100859 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000860 checker_exit="$?"
861 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700862 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000863 good_run="no"
864 else
865 good_run="yes"
866 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000867 else
868 good_run="yes"
869 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700870 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000871 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700872 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700873 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
874 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700875 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700876 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700877 max_name_length=$(getconf NAME_MAX ${tmp_dir})
878 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
879 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700880 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700881 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700882 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700883 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000884 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
885 # output == expected
886 good="yes"
887 echo "${test_dir}: succeeded!" 1>&2
888 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700889 fi
890fi
891
jeffhao5d1ac922011-09-29 17:41:15 -0700892(
Alex Lightbfac14a2014-07-30 09:41:21 -0700893 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700894 echo "${test_dir}: FAILED!"
895 echo ' '
896 echo '#################### info'
897 cat "${td_info}" | sed 's/^/# /g'
898 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700899 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700900 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700901 if [ "$strace" = "yes" ]; then
902 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700903 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700904 echo '####################'
905 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700906 echo ' '
907 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700908
Alex Light91de25f2015-10-28 17:00:06 -0700909) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -0700910
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700911# Attempt bisection only if the test failed.
912if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
913 # Bisecting works by skipping different optimization passes which breaks checker assertions.
914 if [ "$run_checker" == "yes" ]; then
915 echo "${test_dir}: not bisecting, checker test." 1>&2
916 else
917 # Increase file size limit, bisection search can generate large logfiles.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700918 echo "${test_dir}: bisecting..." 1>&2
919 cwd=`pwd`
920 maybe_device_mode=""
921 raw_cmd=""
922 if [ "$target_mode" = "yes" ]; then
923 # Produce cmdline.sh in $DEX_LOCATION. "$@" is passed as a runtime option
924 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
925 # to exec in order to preserve pid when calling dalvikvm. This is required
926 # for bisection search to correctly retrieve logs from device.
927 "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
928 adb shell chmod u+x "$DEX_LOCATION/cmdline.sh"
929 maybe_device_mode="--device"
930 raw_cmd="$DEX_LOCATION/cmdline.sh"
931 else
932 raw_cmd="$cwd/${run} --external-log-tags $run_args $@"
933 fi
934 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
935 $maybe_device_mode \
936 --raw-cmd="$raw_cmd" \
937 --check-script="$cwd/check" \
938 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -0700939 --logfile="$cwd/bisection_log.txt" \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700940 --timeout=300
941 fi
942fi
943
Alex Lightbfac14a2014-07-30 09:41:21 -0700944# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -0700945if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -0700946 cd "$oldwd"
947 rm -rf "$tmp_dir"
948 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
949 adb shell rm -rf $DEX_LOCATION
950 fi
951 if [ "$good" = "yes" ]; then
952 exit 0
953 fi
954fi
955
956
957(
958 if [ "$always_clean" = "yes" ]; then
959 echo "${TEST_NAME} files deleted from host "
960 if [ "$target_mode" == "yes" ]; then
961 echo "and from target"
962 fi
963 else
964 echo "${TEST_NAME} files left in ${tmp_dir} on host"
965 if [ "$target_mode" == "yes" ]; then
966 echo "and in ${DEX_LOCATION} on target"
967 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -0700968 fi
969
Alex Light91de25f2015-10-28 17:00:06 -0700970) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700971
Alex Light6a870fa2016-05-31 16:36:19 -0700972if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
973 exit 0
974else
975 exit 1
976fi